///////////////////////////////////////////////////////////////////////////////
// General.h

#ifndef __DEBUIG_PRINT_HOOK_H__
#define __DEBUIG_PRINT_HOOK_H__

extern "C" {

#pragma pack(push, 1)

#ifndef USER_MODE

#include <ntddk.h>                  // various NT definitions
#include <stddef.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h>
#include "ntddk_ex.h"
#include "tools.h"

#ifdef POOL_TAGGING
#ifdef ExAllocatePool
#undef ExAllocatePool
#endif
#define ExAllocatePool(a,b) ExAllocatePoolWithTag(a,b,'kHPD')
#endif

#else //USER_MODE

// Nothing

#endif

// Device names
#define NT_DbgPrnHk_DOS_NAME     ("\\DosDevices\\DbgPrnHk")
#define NT_DbgPrnHk_NAME         ("\\Device\\DbgPrnHk")
#define NT_DbgPrnHk_USER_NAME    ("\\\\.\\DbgPrnHk")
#define NT_DbgPrnHk_SVC_NAME     ("DbgPrnHk")

#ifndef CTL_CODE
#include "winioctl.h"
#endif

#define PCID_CTL_CODE_X(a,b)    CTL_CODE(FILE_DEVICE_UNKNOWN, a,b, FILE_ANY_ACCESS )

#define IOCTL_DbgPrnHk_GetMessages           PCID_CTL_CODE_X(0x801, METHOD_BUFFERED)
#define IOCTL_DbgPrnHk_SetMessageBuffer      PCID_CTL_CODE_X(0x802, METHOD_BUFFERED)

#define MAX_MSG_SIZE  (64-sizeof(LARGE_INTEGER)-sizeof(USHORT))

typedef struct _DbgPrnHk_GetMessages_USER_OUT {
    LARGE_INTEGER TimeStamp;
    USHORT        Length;
    CHAR          Msg[MAX_MSG_SIZE]; // little shorter than default windows value
} DbgPrnHk_GetMessages_USER_OUT, *PDbgPrnHk_GetMessages_USER_OUT;

typedef struct _DbgPrnHk_SetMessageBuffer_USER_IN {
    ULONG BufferSize;
} DbgPrnHk_SetMessageBuffer_USER_IN, *PDbgPrnHk_SetMessageBuffer_USER_IN;

#ifndef USER_MODE

// Function declarations
extern NTSTATUS DriverEntry(IN PDRIVER_OBJECT DriverObject, IN PUNICODE_STRING RegistryPath);
extern NTSTATUS DbgPrnHkCreateClose(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp);
extern NTSTATUS DbgPrnHkDeviceControl(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp);
extern VOID DbgPrnHkUnload(IN PDRIVER_OBJECT DriverObject);

#endif //USER_MODE

#pragma pack(pop)

};

#endif // __PCI_DUMP_H__

